/* $Id$ */

/* 起動用コード(ここから実行される) */


// TODO: この時点で、もう、各種(SDLとかdddddとか)の初期化用コードを
//       呼ぶべきかどうか考える


/* ↓真のmain関数である、
 * ↓int main_of_mains(char[][])
 * ↓を定義しているモジュールをimportする。
 * ↓(要書き換え) */
import d07.main;




/* ---- 以下は、ブート用の定型コード。いじる必要無し ---- */

private import ddddd.vars;
private import jcode;
private import std.string;

version (Win32) {
  // Boot as the Windows executable.
  private import std.c.windows.windows;
  private import std.string;
  private import std.file;

  enum {
    EXITCODE_OK = 1,
    EXITCODE_FASTEND = 0,
    EXITCODE_ERROR = -1,
  }

  extern (C) void gc_init();
  extern (C) void gc_term();
  extern (C) void _minit();
  extern (C) void _moduleCtor();

  extern (Windows) int WinMain(HINSTANCE hInstance,
      HINSTANCE hPrevInstance,
      LPSTR lpCmdLine,
      int nCmdShow) {
    int result;
    gc_init();
    _minit();
    try {
      _moduleCtor();
      /* argvを生成する
       * (std.c.windows.windowsにはGetCommandLine系が入っていない)
       * TODO: ""で囲まれた引数も上手くパーズできるようにする事
       */
      char exe[4096];
      GetModuleFileNameA(null, &exe[0], 4096);
      char[][1] prog;
      prog[0] = std.string.toString(&exe[0]);
      /* まず最初に、chdir(dirname(prog[0]))を行う。
         TODO: これはargsとして受け取ったpath等にズレを発生させる。
               将来は、何らかの対策が必要だが、今は後回しにする
       */
      char[] dirname = prog[0];
      int i = rfind(prog[0], '\\');
      dirname.length = i;
      /* pathにマルチバイト文字を含むと、chdirに失敗する場合がある。
         その場合は諦めて、chdirしないまま続行する事にする */
      try { chdir(dirname); } catch (Object o) {}
      // main_of_mains()を実行する
      result = main_of_mains(prog ~ std.string.split(std.string.toString(lpCmdLine)));
      /* main()風の返り値をWinMain風に変換する */
      result = result ? EXITCODE_ERROR : EXITCODE_OK;
    } catch (Object o) {
      /* 例外をキャッチした */
      MessageBoxA(cast(HANDLE)ddddd_rw_hwnd, 
          toStringz("Exception: " ~ utf8_sjis(o.toString())),
          "Error",
          MB_OK | MB_ICONEXCLAMATION);
      result = EXITCODE_ERROR; /* 異常終了を示す */
    }
    gc_term();
    return result ? -1 : 0;
  }
  /* NB: WinMain()の返り値は、以下のような仕様らしい
   *     - 正常終了時は、WM_QUITのwParamに入っている終了コードを返すべき
   *       (何を返せば良いのか謎。とりあえず1を返す事にする)
   *     - メッセージループに入る前に終了する場合は0
   *     - どちらでもない場合は謎(とりあえず-1を返す事にする)
   */
}
else {
  // Boot as the general executable.
  public int main(char[][] args) {
    return main_of_mains(args);
  }
}


/* vim:set ft=d sw=2 ts=8 sts=2 et cindent: */
